<?php
/*
Plugin Name: Simple4us
Plugin URI: http://simple4.us
Description: Configura nuestro blog para trabajar con el sistema de afiliación automático Simple4us.
Author: Fernando del Pozo
Version: 0.3.3
License: GPL2
*/

if ( ! defined( 'WPCD_PLUGIN_BASENAME' ) )
	define( 'WPCD_PLUGIN_BASENAME', plugin_basename( __FILE__ ) );

if ( ! defined( 'WPCD_PLUGIN_NAME' ) )
	define( 'WPCD_PLUGIN_NAME', trim( dirname( WPCD_PLUGIN_BASENAME ), '/' ) );

if ( ! defined( 'WPCD_PLUGIN_DIR' ) )
	define( 'WPCD_PLUGIN_DIR', WP_PLUGIN_DIR . '/' . WPCD_PLUGIN_NAME );

if ( ! defined( 'WPCD_PLUGIN_URL' ) )
	define( 'WPCD_PLUGIN_URL', WP_PLUGIN_URL . '/' . WPCD_PLUGIN_NAME );
	



	
// Administration


  function set_plugin_meta($links, $file) {
  $plugin = plugin_basename(__FILE__);
  // create link
  if ($file == $plugin) {
  return array_merge(
  $links,
  array( sprintf( '<a href="options-general.php?page=Simple4us">'. __('Settings').'</a>', $plugin, __('Settings') ) )
  );
  }
  return $links;
  }
add_filter( 'plugin_row_meta', 'set_plugin_meta', 10, 2 );
    
    
add_action('admin_menu', 'simple4us_menu');
function simple4us_menu() {

  add_options_page('Simple4us', 'Simple4us', 'manage_options', 'Simple4us', 'Simple4us_options');

}

add_action( 'plugins_loaded', 'register_filters' );
   
   

function simple4us_script() {
      $s4us_userid = get_option('simple4us_userid');
      $s4us_enabled = get_option('simple4us_enabled');
      if($s4us_userid!='' && $s4us_enabled=='on')
      {

	echo '<script src="http://simple4.us/embed/s4us.php?userid='.$s4us_userid.'"></script>';
      }
  }

add_action ('wp_footer', 'simple4us_script',100);


function register_filters() {
      if(get_option('simple4us_words_enabled')=='on' && get_option('simple4us_enabled' )=='on' && get_option('simple4us_words_keywords' )!='')
      {
        		$filters = apply_filters( 'simple4us_words_filters', array( 'the_content', 'the_excerpt', 'widget_text','get_comment_text','get_comment_text' ) );
        		foreach ( (array) $filters as $filter )add_filter( $filter, 'simple4us_words', 2 );
 
      }
	}

function simple4us_words( $text ) {
  $s4us_words_keywords = new SimpleXMLElement(get_option('simple4us_words_keywords' ));
  $density=get_option('simple4us_words_density');
  setlocale(LC_ALL,"es_ES"); 

	$text = ' ' . $text . ' ';
	  $total_words=0;
    
    foreach ( $s4us_words_keywords->item as $word ) {
    
    preg_replace( "|(?!<.*?)\b$word->keyword\b(?![^<>]*?>)|siu", $new_text, $text,-1,$words );
    $total_words=$total_words + $words;
    
    }
    
    $max_words = (int)((($total_words * $density) / 100)/2)+1;
    
		foreach ( $s4us_words_keywords->item as $word ) {
      preg_replace( "|(?!<.*?)\b$word->keyword\b(?![^<>]*?>)|siu", $new_text, $text,-1,$words );
      if($density==100)
      {
        $max_words = $words;
      }
      else
      {
        $max_words = (int)((($words * $density) / 100)/2)+1;
      }
      if(count(explode(".", $word->url))>2){$newurl=$word->url;}else{$newurl='www.'.$word->url;} 
			$new_text = '<a href="' . esc_url( $newurl ) . '" s4pid="2" title="" target="_blank" rel="nofollow">' . $word->keyword . '</a>';
			$new_text = apply_filters( 'simple4us_words_filters', $new_text, $word->keyword, $newurl );
			$text = preg_replace( "|(?!<.*?)\b$word->keyword\b(?![^<>]*?>)|siu", $new_text, $text,$max_words );
		}
		
		$text = preg_replace( "#(<a [^>]+>)(.*)<a [^>]+>([^<]*)</a>([^>]*)</a>#iU", "$1$2$3$4</a>" , $text );
	
	
  return trim( $text );
} 

//Simplefeeds
function Simple4us_feeds($content) {
$active_campaigns = get_option('simple4us_feeds_activecampaigns');
$campaigns_ids = get_option('simple4us_feeds_campaigns_ids' );
$valid_campaigns_ids = array_intersect ($campaigns_ids,$active_campaigns);
 

if ($valid_campaigns_ids)
{
    //$campaign_id = array_rand($valid_campaigns_ids, 1);
    $index_id = array();
    $index_id = array_rand($valid_campaigns_ids);
    $campaign_id = $valid_campaigns_ids[$index_id];
    

     
    $campaigns = new SimpleXMLElement(get_option('simple4us_feeds_campaigns'));
    foreach ($campaigns->item as $campaign)
    {
        if ($campaign->id==$campaign_id)
        {

          $s4us_lead = '</br></br>
                        <h3>Recomendado solo para suscriptores:</h3>
                        <table CELLPADDING=5 style="width:100%;border-radius: 5px; border: 1px solid #DDDDDD; padding:5; background-color: #FFFFFF;">
                        <tr>
                        <td><a href="'.$campaign->url.'&s4pid=4" rel="nofollow" target="_blank"><img src="http://panel.simple4.us/logos/logo_'.$campaign->slug.'.gif" style="max-height:60px;border: 2px solid ##DDDDDD;border-radius: 5px 5px 5px 5px;box-shadow: 0 0 4px #D0D0D0;max-width:150px;"></a></td>
                        <td>'.$campaign->text.'</td>
                        <td>
                        </tr>
                        <tr><td></td><td style="text-align:right;"><a href="'.$campaign->url.'&s4pid=4" rel="nofollow" target="_blank"><strong>Haz click para saber más.</strong></a></td></tr>
                        </table>
                        </a>'; 
                        break;        
        }   
    }
    return $content.$s4us_lead;
    
}


}


if (get_option('simple4us_feeds_activecampaigns' )!='' && get_option('simple4us_feeds_enabled' )=='on')
{
    add_filter('the_excerpt_rss', 'Simple4us_feeds',99);
    add_filter('the_content_feed', 'Simple4us_feeds',99);

}


include('dashboard.php');

include('s4us_settings.php');


function simple4us_plugin_start() {


  
 
}

function simple4us_activate() {

 if(get_option('simple4us_userid')=='')
 {
 update_option( 'simple4us_words_enabled','on');
 update_option( 'simple4us_words_density','50');
 }
 
 if (get_option('simple4us_feeds_enabled',"NULL")=="NULL")update_option( 'simple4us_feeds_enabled','on');
 
 s4us_panel_function();
    
}


function simple4us_deactivate() {

remove_action('s4us_panel_hook', 'gz_panel_deactivate');
  
}

register_activation_hook( __FILE__, 'simple4us_activate' );
register_deactivation_hook( __FILE__, 'simple4us_deactivate' );

if ( !wp_next_scheduled('s4us_panel_hook') ) {
wp_schedule_event( time(), 'twicedaily', 's4us_panel_hook' ); // hourly, daily and twicedaily
}
function s4us_panel_function() {

$s4us_key = get_option('simple4us_key' );
$domain = GetDomain(get_option('siteurl'));

          //SimpleWords
          $curl_handle = curl_init();  
          curl_setopt($curl_handle, CURLOPT_URL, 'http://api.simple4.us/api/programs_keywords/domain/'.$domain);
          curl_setopt($curl_handle,CURLOPT_HTTPHEADER,array("SIMPLE4US-API-KEY:".$s4us_key));
          curl_setopt($curl_handle, CURLOPT_RETURNTRANSFER, 1);
            
          $buffer = curl_exec($curl_handle);  
          curl_close($curl_handle);  
            
          

          $xml_keywords = $buffer;
          update_option( 'simple4us_words_keywords',$xml_keywords);
          
         //Simplefeeds  

          $curl_handle = curl_init();  
          curl_setopt($curl_handle, CURLOPT_URL, 'http://api.simple4.us/api/simplefeeds_campaigns/domain/'.$domain);
          curl_setopt($curl_handle,CURLOPT_HTTPHEADER,array("SIMPLE4US-API-KEY:".$s4us_key));
          curl_setopt($curl_handle, CURLOPT_RETURNTRANSFER, 1);
            
          $buffer = curl_exec($curl_handle);  
          curl_close($curl_handle);  
            
          

          $xml_campaigns = $buffer;                
          update_option( 'simple4us_feeds_campaigns',$xml_campaigns);
}
add_action('s4us_panel_hook', 's4us_panel_function');


function simple4us_notice(){
/*if (get_option('simple4us_feeds_enabled',"NULL")=="NULL")
{
    echo '<div class="updated">
       <p>SIMPLE4US: SimpleFeeds está ahora desactivado, actívalo en <a href="options-general.php?page=Simple4us">configuración</a>.</p>
    </div>';
} */
    
}

add_action('admin_notices', 'simple4us_notice')

?>